﻿$(function() {
  $('#gamePanes').css({bottom: 9, minHeight: 'initial', height: 'auto', width: 250, overflowX: 'hidden', overflowY: 'auto'});
  $('#gamePanesRunning #gamePanesFinished').css({width: 216, right: 32});

  // Include a set of resize functions to choose from
  var builtInResizeFunctions = {
    proportional: function() {
      // enlarge both panes to fit their contents
      $('.elementListWrapper').css({maxHeight: 'initial'});

      // Work out how much we need to shrink the panes by.
      var spaceNeeded = $('#gamePanesRunning').outerHeight(true) - $('#gamePanes').height();
      if (spaceNeeded > 0) {
        // determine the total size available for the panes
        var totalHeight = $('#inventoryWrapper').height() + $('placesObjectsWrapper').height();
        var availableSpace = totalHeight - spaceNeeded;

        // and how much space each list should be sized to
        var inventoryHeight = Math.floor($('#inventoryWrapper').height() * availableSpace / totalHeight);
        var placesObjectsHeight = Math.floor($('#placesObjectsWrapper').height() * availableSpace / totalHeight);

        // make sure that there's actually space for both lists
        //   (if the window is really small or there are other panes that are huge, don't shrink the lists)
        var sizeMinimum = $('.elementList').children('li').outerHeight() * 2;
        if (availableSpace > sizeMinimum * 2) {
          if (inventoryHeight < sizeMinimum) {
            inventoryHeight = sizeMinimum;
            placesObjectsHeight = availableSpace - inventoryHeight;
          } else if (placesObjectsHeight < sizeMinimum) {
            placesObjectsHeight = sizeMinimum;
            inventoryHeight = availableSpace - placesObjectsHeight;
          }
          $('#placesObjectsWrapper').css({maxHeight: placesObjectsHeight});
          $('#inventoryWrapper').css({maxHeight: inventoryHeight});
        }
      }
    },
    equal: function() {
      // enlarge both panes to fit their contents
      $('.elementListWrapper').css({maxHeight: 'initial'});

      // Work out how much we need to shrink the panes by.
      var spaceNeeded = $('#gamePanesRunning').outerHeight(true) - $('#gamePanes').height();
      if (spaceNeeded > 0) {

        // find out if shrinking the larger pane to the size of the smaller one would be sufficient
        var totalHeight = $('#inventoryWrapper').height() + $('placesObjectsWrapper').height();
        var smallerHeight = Math.min($('#inventoryWrapper').height(), $('placesObjectsWrapper').height());

        var targetHeight = (totalHeight - spaceNeeded > smallerHeight * 2) ?
          (totalHeight - smallerHeight - spaceNeeded) :
          Math.floor((totalHeight - spaceNeeded) / 2);

        // And make sure there's enough space before shrinking
        if (targetHeight > $('.elementList').children('li').outerHeight() * 3) {
          $('.elementListWrapper').css({maxHeight: targetHeight});
        }
      }
    },
    'global': function() {
      $('.elementListWrapper').css({maxHeight: 'initial'});
    }
  };

  // The resize function is in a framed variable to let it be modified.
  // By default it does nothing
  var resizePanes = function() {};

  changePaneResizeMode = function (mode) {
    if (typeof mode == 'function') {
      resizePanes = mode;
    } else if (builtInResizeFunctions[mode]) {
      resizePanes = builtInResizeFunctions[mode];
    } else if (mode) {
      resizePanes = eval(mode);
    } else {
      resizePanes = builtInResizeFunctions['equal'];
    }
    // And resize now, to make sure everything is initially set up right
    resizePanes();
  };

  // Make a copy of the default functions
  // Your game probably doesn't need all of these, but they're included so this code can be used
  //   without modification in other games
  var originalUpdateList = updateList;
  var originalUpdateVerbButtons = updateVerbButtons;
  var originalUpdateStatus = updateStatus;
  var originalSetCustomStatus = setCustomStatus;
  var originalUpdateStatusVisibility = updateStatusVisibility;
  var originalShowStatusVisible = showStatusVisible;
  var originalShow = uiShow;
  var originalHide = uiHide;

  // Then we replace each of those functions with one that calls the original version,
  //   and then calls resizePanes()
  updateList = function(name, data) {
    originalUpdateList(name, data);
    resizePanes();
  };
  updateVerbButtons = function(item, arr, prefix) {
    originalUpdateVerbButtons(item, arr, prefix);
    resizePanes();
  };
  updateStatus = function(txt) {
    originalUpdateStatus(txt);
    resizePanes();
  };
  setCustomStatus = function(txt) {
    originalSetCustomStatus(txt);
    resizePanes();
  };
  updateStatusVisibility = function() {
    originalUpdateStatusVisibility();
    resizePanes();
  };
  showStatusVisible = function(t) {
    originalShowStatusVisible(t);
    resizePanes();
  };
  uiShow = function(elem) {
    originalShow(elem);
    resizePanes();
  };
  uiHide = function(elem) {
    originalHide(elem);
    resizePanes();
  };

  // And we might also need to adjust the scroll bars when the window is resized
  $(window).resize( function() { resizePanes(); } );
});